/*
 * Atmega128_TIR.c
 * 소스 공개용
 * Created: 2021-03-24 오후 2:25:09
 * Author: 강건일  

* 210323 : PCB ( SMT 4 차) : Atmega128 Sensor R1 에서 수정
        *.LED 전용으로 간단하게 구성
		*.Thermopile Infrared Amplifier3 을 적용할 수 있게 구성.----ADC3
		*.KB120 을 적용할 수 있게 구성 -----ADC1, SW2 (PD1) 가 눌리면 KB120 출력 값이 표시된다.
    	*.PC0 ~ PC7 을 I/O 로 사용	
		*. Normal 동작  : CON 1 의 출력을 읽는다.
		   SWITCH 2가 눌릴때 : CON 2 의 출력을 읽는다
*/

#include <avr/eeprom.h>  
#include <avr/io.h>
#include <stdio.h>
#include <math.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "iseg7.cpp"
#include "iseg7 source.c"   
#include "button123.cpp"    
#include "button switch123.c"

#define  N_CHANNEL   4           // 채널 읽기from 4
#define  setup   20           // 온도 안정화setup 반복, 시간이 길어야 pcb 내 온도가 안정 됨,

static int i;
static int k;

static int ref1;
static int ref21;
static int ref31;
static int ref311;

static unsigned int adresult[4] ;  //인터럽시 값
void msec_delay (int n);

int main(void)

{
   int j; // 온도 setup delay
   int adresult[N_CHANNEL];           // 처리 속도 개선
   int i; 		 //for 문
   int k;      // TP2 평균값 용
   long int  ref0, ref1, ref2, ref3,ref31,ref4,ref01, ref11,ref21,ref211,Temp, tp2, ref311,spl,DV,stdby, stdby0,stdby1 ;

   ref0, ref1, ref2, ref3,ref31,ref4,ref01, ref11,ref21,ref211, ref311, Temp, tp2, spl,DV, stdby,stdby0,stdby1 = 0 ; //clear
   // 변수 추가, ref 는 기준값 변수

   DDRA = 0xFF; //PORT A 를 출력 포트
   DDRC = 0xFF ; // PORC 를 출력 포트
   DDRB = 0xFF; // PORT B를 출력 포트
   DDRD = 0xF0; // PORT D 상위 출력 포트, 하위 4 bit 는 입력포트

   PORTA = 0x00; //seg L= on
   PORTD = 0x00; //digit L = on
   msec_delay(80000); // 약 5000ms on

   sei ();
   ISeg7Init();   

   for ( j=0; j<setup ;j++)  // 온도 회로 setup 지연 함수
   {
           
	   sei ();
	   ISeg7Init();

	   ADCSRA = (1<<ADEN) | (7<<ADPS0) ;
	   //  프리스켈러 분주 = 128, smpling rate=> 16MHz / 128 = 125 KHz  /13 clock =9.6KHz
	   // 200528 : 초기에 DV 오동작과 감지 led 켜짐 보완을 위해 Analog 읽기 추가
	   
	   for ( i=0; i<N_CHANNEL;i++)
	   {
		   ADMUX = (1<<REFS0) | (i<<MUX0) ;  // 내부2.56v 일때3 그리고 5v일때는 1임, .
		   //실험 보드에서 ref가 5v 이고 입력 전압이 3V는led 디스플레이에서  614로 표기됨

		   ADCSRA |= (1<<ADSC) ; // AD 변환 시작

		   while(!(ADCSRA & (1<<ADIF))) ; //변환 종료를 기다림

		   ADCSRA |= (1<<ADIF) ; // ADIF 플레그 지움
		   adresult[i] = ADC ;

		   adresult[i] = adresult[i] * 5 ;
		   //실제 측정된 전압 표기값으로 표기.ex) 입력 5v *1024 /Ref 5= 1024.wmr 1024 가 표기 된다.
		   //이것을 실제 전압 mv로 만들기 위해 *5 함

		   ref31 =  adresult[3];  // TP2
		   ref21 =  adresult[2];  // nc
		   ref1 = adresult[1];  // SPL for voice, 
		   ref01 =  adresult[0];  // ADC0 입력		   
		
	   }

	   ISeg7DispNum (ref31,10) ; // 실시간 값

	   if ( ref31 >= 3100)
	   {
		   PORTB = 0b00000000 ;
	   }
	  	  
	   else
	   {
		   PORTB = 0b11111111 ; // 
	   }

	  msec_delay(1600) ;	// 100ms 지연

	   for ( i=0; i<N_CHANNEL;i++)
	   {
		   ADMUX = (1<<REFS0) | (i<<MUX0);  // 내부2.56v 일때3 그리고 5v일때는 1임, .
		   //실험 보드에서 ref가 5v 이고 입력 전압이 3V는led 디스플레이에서  614로 표기됨

		   ADCSRA |= (1<<ADSC); // AD 변환 시작

		   while(!(ADCSRA & (1<<ADIF))); //변환 종료를 기다림

		   ADCSRA |= (1<<ADIF); // ADIF 플레그 지움
		   adresult[i] = ADC;

		   adresult[i] = adresult[i] * 5 ;
		   //실제 측정된 전압 표기값으로 표기.ex) 입력 5v *1024 /Ref 5= 1024.wmr 1024 가 표기 된다.
		   // 이것을 실제 전압 mv로 만들기 위해 *5 함

		   ref311=  adresult[3];  // TP2

		   ref211 =  adresult[2];  // nc

		   ref1 =  adresult[1];  // SPL for voice , NC

		   ref01 =  adresult[0];  // SVR

	   }
	 	 
	   ISeg7DispNum (ref311,10) ; // 실시간 값

	   if ( ref311 >= 3200)
	   {
		   PORTB = 0b00000000 ;
	   }  	 

	   else
	   {
		   PORTB = 0b11111111 ; //10 이하일대 PB3 은 high, relay off
	   }

	  msec_delay(1600) ;	// 100ms 지연

   }
        
	// 예열을 위한 setup 끝				 

   while (1)   // 여기부터가 실제 main 동작임

   {
       
	   while ( ( ~ PIND & 0b00000001))  
	   //PD0 (INT0 스위치)이 눌리면 (High---> low)이면 기존 program이 stop 되고 음성 크기 spl 값 표기 동작

	   {            
		  sei ();
		
		  ADCSRA = (1<<ADEN) | (7<<ADPS0) ;
		  //  프리스켈러 분주 = 128, smpling rate=> 16MHz / 128 = 125 KHz  /13 clock =9.6KHz
		  // 200528 : 초기에 DV 오동작과 감지 led 켜짐 보완을 위해 Analog 읽기 추가
		  
		  for ( i=0; i<N_CHANNEL;i++)
		  {
			  ADMUX = (1<<REFS0) | (i<<MUX0) ;  // 내부2.56v 일때3 그리고 5v일때는 1임, .
			  //실험 보드에서 ref가 5v 이고 입력 전압이 3V는led 디스플레이에서  614로 표기됨

			  ADCSRA |= (1<<ADSC) ; // AD 변환 시작

			  while(!(ADCSRA & (1<<ADIF))) ; //변환 종료를 기다림

			  ADCSRA |= (1<<ADIF) ; // ADIF 플레그 지움
			  adresult[i] = ADC ;

			  adresult[i] = adresult[i] * 5 ;
			  //실제 측정된 전압 표기값으로 표기.ex) 입력 5v *1024 /Ref 5= 1024.wmr 1024 가 표기 된다.
			  //이것을 실제 전압 mv로 만들기 위해 *5 함

			  ref31=  adresult[3];  // TP2
			  ref21 =  adresult[2];  // nc
			  ref1=  adresult[1];  // SPL for voice,
			  ref01 =  adresult[0];  // SVR			  
		  }
		  		  
		   ISeg7DispNum (ref1,10) ;

	//	   PORTB = 0b00001110; // 개별 LED 5개 on // Active low
		   PORTA = 0x00; //seg L= on
		   PORTD = 0x00; //digit L =on

	      msec_delay(1600); // 약 100ms on	Based on 16Mhz CLK, 지연 없으면 디스플레이 글씨가 잘 안보임
		  
	   }

	   // 여기부터 기본 ,Thermopile TP2 전압 측정과 감지 출력 표시

	   //data += 10; // 10에서 1로 변경 10은 10자리부터 시작되고 1은 첫 자리부터 시작.

	   for ( i=0; i<N_CHANNEL;i++)
	   {
		   ADMUX = (1<<REFS0) | (i<<MUX0) ;  // 내부2.56v 일때3 그리고 5v일때는 1임, .
		   //실험 보드에서 ref가 5v 이고 입력 전압이 3V는led 디스플레이에서  614로 표기됨

		   ADCSRA |= (1<<ADSC) ; // AD 변환 시작

		   while(!(ADCSRA & (1<<ADIF))) ; //변환 종료를 기다림

		   ADCSRA |= (1<<ADIF) ; // ADIF 플레그 지움
		   adresult[i] = ADC ;

		   adresult[i] = adresult[i] * 5 ;
		   //실제 측정된 전압 표기값으로 표기.ex) 입력 5v *1024 /Ref 5= 1024.wmr 1024 가 표기 된다.
		   //이것을 실제 전압 mv로 만들기 위해 *5 함

		   ref31=  adresult[3];  // Thermopile Sensor 출력 TP2

		   ref21 =  adresult[2];  //nc,

		   ref1=  adresult[1];  // SPL for voice, NC

		   ref01 =  adresult[0];  // ADC0 입력
	   }

	   tp2 = (ref31 + ref311 ) / 2 ; // 실시간 tp2 값
	  	  
	   ISeg7DispNum (tp2,10) ; // 실시간 값
	   
	   if (ref31 > ( ref311 + 150) )  // 전번 값 보다 현재 값이 크면 
	   
	   {
		   PORTB = 0b00000000 ;
	   }	   
	   
	   else if (ref31 > ( ref311 + 100) ) 
	   {
		   PORTB = 0b10000000 ;
	   }

	    else if (ref31 > ( ref311 + 50) )
	    {
		    PORTB = 0b11000000 ;
	    }
		
		  else if (ref31 > ( ref311 + 10) )
		  {
			  PORTB = 0b11100000 ;
			  		  }

	   else
	   {
		   PORTB = 0b11111111 ; // 10 이하일때 PB3 = high
	   }

      

	 msec_delay(800) ;	// 50ms 지연

	   for ( i=0; i<N_CHANNEL;i++)
	   {
		   ADMUX = (1<<REFS0) | (i<<MUX0);  // 내부2.56v 일때3 그리고 5v일때는 1임, .
		   //실험 보드에서 ref가 5v 이고 입력 전압이 3V는led 디스플레이에서  614로 표기됨

		   ADCSRA |= (1<<ADSC); // AD 변환 시작

		   while(!(ADCSRA & (1<<ADIF))); //변환 종료를 기다림

		   ADCSRA |= (1<<ADIF); // ADIF 플레그 지움
		   adresult[i] = ADC;

		   adresult[i] = adresult[i] * 5 ;
		   //실제 측정된 전압 표기값으로 표기.ex) 입력 5v *1024 /Ref 5= 1024.wmr 1024 가 표기 된다.
		   // 이것을 실제 전압 mv로 만들기 위해 *5 함

		   // ref31=  adresult[3];  // NC

		   ref311 =  adresult[3];  // FP2 ,Tp2 2차 amp 출력 값,

		   ref1 =  adresult[1];  // SPL for voice , NC

		   ref01 =  adresult[0];  // SVR ,NC

	   }

	   tp2 = (ref31 + ref311 ) / 2 ; // 실시간 tp2 값

 if (ref311 > ( ref31 + 150) )  // 전번 값 보다 현재 값이 크면
 
 {
	 PORTB = 0b00000000 ;
 }
 
 else if (ref311 > ( ref31 + 100) )
 {
	 PORTB = 0b10000000 ;
 }

 else if (ref311 > ( ref31 + 50) )
 {
	 PORTB = 0b11000000 ;
 }
 
 else if (ref311 > ( ref31 + 10) )
 {
	 PORTB = 0b11100000 ;
 }

 else
 {
	 PORTB = 0b11111111 ; // 10 이하일때 PB3 = high
 }

	  msec_delay(800) ;	// 50ms 지연
   }   
        }

   void msec_delay (int n)
   {
	   for (; n>0; n--)
	   _delay_ms(1);  // 시간 지연하려면 (2)로 한다//TODO:: Please write your application code
   }

   //end


